# mypy-boto3-route53

[![PyPI - mypy-boto3-route53](https://img.shields.io/pypi/v/mypy-boto3-route53.svg?color=blue)](https://pypi.org/project/mypy-boto3-route53)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-route53.svg?color=blue)](https://pypi.org/project/mypy-boto3-route53)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-route53](#mypy-boto3-route53)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.Route53 1.13.24](https://boto3.amazonaws.com/v1/documentation/api/1.13.24/reference/services/route53.html#Route53) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-route53](#mypy-boto3-route53)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `Route53` service.

```bash
python -m pip install boto3-stubs[route53]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_route53` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_route53 import Route53Client

# Now mypy can check if your code is valid.
client: Route53Client = boto3.client("route53")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: Route53Client = session.client("route53")



# Waiters are also supported

import mypy_boto3_route53.waiter as route53_waiters

resource_record_sets_changed_waiter: route53_waiters.ResourceRecordSetsChangedWaiter = client.get_waiter("resource_record_sets_changed")


# Annotated paginators are included as well

import mypy_boto3_route53.paginator as route53_paginators

list_health_checks_paginator: route53_paginators.ListHealthChecksPaginator = client.get_paginator("list_health_checks")
list_hosted_zones_paginator: route53_paginators.ListHostedZonesPaginator = client.get_paginator("list_hosted_zones")
list_query_logging_configs_paginator: route53_paginators.ListQueryLoggingConfigsPaginator = client.get_paginator("list_query_logging_configs")
list_resource_record_sets_paginator: route53_paginators.ListResourceRecordSetsPaginator = client.get_paginator("list_resource_record_sets")
list_vpc_association_authorizations_paginator: route53_paginators.ListVPCAssociationAuthorizationsPaginator = client.get_paginator("list_vpc_association_authorizations")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_route53` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_route53 as route53
from mypy_boto3_route53 import Route53Client

# with these
from mypy_boto3 import route53
from mypy_boto3.route53 import Route53Client
```